/*
 * @(#)file      CommonApiTckTest.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.7
 * @(#)date      02/02/26
 *
 * Copyright 2002 Sun Microsystems, Inc. All rights reserved.
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 * Copyright 2002 Sun Microsystems, Inc. Tous droits rservs.
 * Ce logiciel est propriet de Sun Microsystems, Inc.
 * Distribu par des licences qui en restreignent l'utilisation.
 */
package ossj.common.tck;

import junit.framework.Test;
import junit.framework.TestSuite;

import ossj.common.tck.tests.*;


/**
 * Test Suite for the OSS Common API (JSR144) TCK
 *
 */
public class CommonApiTckTest {
    /**
     * DOCUMENT ME!
     *
     * @param args DOCUMENT ME!
     *
     * @throws Exception DOCUMENT ME!
     */
    public static void main(String[] args) throws Exception {
        junit.textui.TestRunner.run(suite());
    }

    /**
     * Buits the tests suites
     *
     * @return the Test
     *
     * @throws Exception any kind of
     */
    public static Test suite() throws Exception {
        String profile = System.getProperty("INTEGRATION_PROFILE");

        // ========================
        //  Main test suite 
        // ========================
        TestSuite rootsuite = new TestSuite("JSR144-OSS Common API TCK, Java Integartion profile");

        if (profile.compareToIgnoreCase("java") == 0) {
            // ========================
            //  COMMON PART
            // ========================
            TestSuite commonSuite = new TestSuite("JSR144-OSS Common API Java Profile Test Suite");

            // -------------
            // CBE Basic Test
            // -------------
            System.err.println("Java OSS Common API Tests");

            TestSuite cbeBasic = new TestSuite("Cbe Basic Tests");
            cbeBasic.addTest(TestCbeBasics.suite());
            commonSuite.addTest(cbeBasic);

            // -------------
            // Basic Test
            // -------------
            TestSuite basic = new TestSuite("Basic Test");
            basic.addTest(TestBasics.suite());
            commonSuite.addTest(basic);

            // -------------
            // ManagedEntityValue Test
            // -------------
            TestSuite entityValue = new TestSuite("ManagedEntityValue");
            entityValue.addTest(TestManagedEntityValueSingle.suite());
            commonSuite.addTest(entityValue);

            // -------------
            // Event value Test
            // -------------
            TestSuite eventValue = new TestSuite("Event Tests (AttributeAccess)");
            eventValue.addTest(TestEventValue.suite());
            commonSuite.addTest(eventValue);

            // -------------
            // QueryValue Test
            // -------------
            TestSuite queryValue = new TestSuite("QueryValue");
            queryValue.addTest(TestQueryValueSingle.suite());
            commonSuite.addTest(queryValue);

            // -------------
            // UpdateProcedureValue Test
            // -------------
            TestSuite upvValue = new TestSuite("UpdateProcedureValue");
            upvValue.addTest(TestUpvSingle.suite());
            commonSuite.addTest(upvValue);

            // -------------
            // JVTSession Test
            // -------------
            TestSuite jvtActivationSession = new TestSuite("JVTSession");
            jvtActivationSession.addTest(TestJVTSessionSimple.suite());
            commonSuite.addTest(jvtActivationSession);

            // -------------
            // ManagedEntityKey Test
            // -------------
            TestSuite managedEntity = new TestSuite("ManagedEntityKey");
            managedEntity.addTest(TestManagedEntityKey.suite());
            commonSuite.addTest(managedEntity);

            rootsuite.addTest(commonSuite);

            // ========================
            //  Return PART
            // ========================
            return rootsuite;
        } else if (profile.compareToIgnoreCase("xml") == 0) {
            // ========================
            //  COMMON PART
            // ========================
            TestSuite commonSuite = new TestSuite("JSR144-OSS Common API Xml Profile Test Suite");

            // -------------
            // CBE Basic Test
            // -------------
            System.err.println("Xml OSS Common API Tests");

            TestSuite xml = new TestSuite("Xml Tests");
            xml.addTest(XmlTests.suite());
            commonSuite.addTest(xml);

            rootsuite.addTest(commonSuite);

            // ========================
            //  Return PART
            // ========================
            return rootsuite;
        } else {
            System.err.println("Unknown integration profile: " + profile);

            return null;
        }
    }
}
