/*
 * SysProps.java
 *
 *
 */
package ossj.common.tck;

import java.io.IOException;


/**
 * System property names
 * @author  BanuPrasad
 * @version
 */
public class SysProps extends SafeProperties {
    // fields in jsr144_oss_common-1_0-tck_properties.txt

    /**(required property) property name for tracing */
    public static final String LOGGING_ENABLED = "logging_enabled";

    /**(required property) property name for logging trace */
    public static final String LOGFILE = "log_file";

    /**(required property) property name for the Jar name to be introspect */
    public static final String JARNAME = "jar_name";

    /**(required property) property name for the Jar name to be introspect */
    public static final String XMLSCHEMANAME = "xml_schema_name";

    /**(required property) property name of the jndi factory name*/
    public static final String JNDIFACTORY = "jndi_factory_class";

    /**(required property) property name of the url of the jndi service*/
    public static final String JNDIURL = "jndi_url";

    /**(required property) property name of the queue name where respnses are expected*/
    public static final String TOPICFACTORYJNDINAME = "topic_factory_jndi_name";

    /**(required property) property name of the queue name where respnses are expected*/
    public static final String JVTTOPICJNDINAME = "jvt_topic_jndi_name";

    /**(required property) property name of the queue name where respnses are expected*/
    public static final String XVTTOPICJNDINAME = "xvt_topic_jndi_name";

    /**(required property) property name of the queue name where respnses are expected*/
    public static final String QUEUEFACTORYJNDINAME = "queue_factory_jndi_name";

    /**(required property) property name of the queue name where respnses are expected*/
    public static final String REQUESTQUEUEJNDINAME = "request_queue_jndi_name";

    /**(required property) property name of the queue name where respnses are expected*/
    public static final String RESPONSEQUEUEJNDINAME = "response_queue_jndi_name";

    /**(required property) property name of the maximum string length*/
    public static final String MAXSTRINGLENGTH = "max_string_length";

    /**(required property) property name of the event timeout */
    public static final String EVENTTIMEOUT = "event_timeout";

    /**(required property) property name of the total timeout for a event */
    public static final String TOTALTIMEOUT = "total_timeout";
    private static final String[] REQUIREDPROPARRAY = new String[] {
            LOGGING_ENABLED, LOGFILE, JARNAME, XMLSCHEMANAME, JNDIFACTORY, JNDIURL,
            TOPICFACTORYJNDINAME, JVTTOPICJNDINAME, QUEUEFACTORYJNDINAME,
	        REQUESTQUEUEJNDINAME,

        //XVTTOPICJNDINAME,
        //RESPONSEQUEUEJNDINAME,
        //MAXSTRINGLENGTH,
        //EVENTTIMEOUT,
        //TOTALTIMEOUT
        };

    /**
        creates a new SysProps instance
        @param propFilename The file containing the properties
        @throws IOException If the file cannot be read
        @throws IllegalArgumentException If not all required properties are present
    */
    public SysProps(String propFilename) throws IOException, IllegalArgumentException {
        super(propFilename, SysProps.REQUIREDPROPARRAY);
    }
}
