/*
 * TCKException.java
 *
 *
 */
package ossj.common.tck;

import java.io.*;


/**
 * Simple class to provide more detailed information for unexpected implementation exceptions
 * The implementation exception is wrapped, a description added an the new TCKException thrown
 * @author  BanuPrasad
 * @version 0.1
 */
public class TCKException extends Exception {
    private Throwable nested;

    /** Creates new TCKException
        @param msg the exception msg
    */
    public TCKException(String msg) {
        super(msg);
        this.nested = null;
    }

    /** Creates new TCKException
        @param msg the exception msg
        @param nested The Exception thrown by the implementation
    */
    public TCKException(String msg, Throwable nested) {
        super(msg);
        this.nested = nested;
    }

    /** Creates new TCKException
        @param name The name of the current attribute
        @param type The type of the current ManagedEntityValue
        @param nested The Exception thrown by the implementation
    */
    public TCKException(String name, String type, Exception nested) {
        super((null == name) ? (StringTable.TYPE + type)
                             : (StringTable.ATTRIBUTE + name + StringTable.TYPE + type));
        this.nested = nested;
    }

    /**
     * DOCUMENT ME!
     */
    public void printStackTrace() {
        super.printStackTrace();

        if (null != this.nested) {
            nested.printStackTrace();
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param s DOCUMENT ME!
     */
    public void printStackTrace(PrintStream s) {
        super.printStackTrace(s);

        if (null != this.nested) {
            nested.printStackTrace(s);
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param s DOCUMENT ME!
     */
    public void printStackTrace(PrintWriter s) {
        super.printStackTrace(s);

        if (null != this.nested) {
            nested.printStackTrace(s);
        }
    }
}
